#include <windows.h>
#include "ADCLib.h"
#include "CoprocLib.h"
 
int wmain()
{
    CHAR exitChar = '0';
    BYTE adcChannel = 0;
    BOOL ret = FALSE;
    DWORD samples = 1;
    DWORD data = 0;
    DWORD procID = 0;
    DWORD versionMajor = 0;
    DWORD versionMinor = 0;
    DWORD versionBuild = 0;
    double temp = 0; 
    
    printf("Demo on How to use ADC Library\n");
    ADCGetLibVersion(&versionMajor, &versionMinor, &versionBuild);   ///< Obtain the ADC library version
    printf("ADCLib Version: %d.%d.%d\n", versionMajor, versionMinor, versionBuild);
    procID = getPROCID();   ///< Get processor ID 
    printf("Processor Type:\t");
    switch(procID)
    {
        case TYPE_PXA270:
            printf("PXA270 detected\n");
            printf("ADC Resolution is: 12-bits\n");
            break;
        case TYPE_PXA320:
            printf("PXA320 detected\n");
            printf("ADC Resolution is: 12-bits\n");
            break;
        case TYPE_PXA300:
            printf("PXA300 detected\n");
            printf("PXA300 ADC feature is not present, PXA300XT resolution is 12-bits\n");
            break;
        case TYPE_PXA310:
            printf("PXA310 detected\n");
            printf("ADC Resolution is: 12-bits\n");
            break;
        case TYPE_TEGRA2:
            printf("Tegra 2 detected\n");
            printf("ADC Resolution is: 12-bits\n");
            break;
		case TYPE_TEGRA3:
            printf("Tegra 3 detected\n");
            printf("ADC Resolution is: 12-bits\n");
            break;
        default:
            printf("Processor type unknown\n");
            return FALSE;
            break;
    }
    if (!Ac97Init())   ///< Initialize AC97 interface and get a MUTEX for the AC97 access (also used by Touch panel and Sound driver)
    {
        printf("Could not initialize codec\n");
        getchar();
        return FALSE;
    }
    printf("Codec Details:\t");
    switch(getCodecType())
    {
        case 0:
            printf("UNKNOWN Codec !\n");
            break;
        case 1:
            printf("UCB1400 Codec\n");
            break;
        case 2:
            printf("WM9713 Codec\n");
            break;
        case 3:
            printf("WM9715 Codec\n");
            break;
    }
    printf("ADC raw data\t\tADC actual value\n");
    while(exitChar != 'e')
    {
        for (adcChannel = 0; adcChannel < 4; adcChannel++)
        {
            ret = ReadADCChannel(adcChannel, &data, samples);   ///< Read ADC channel
            temp = (double)(MicrovoltsPerLsb(adcChannel)*data) / (1000000.0*samples);
            printf("Channel_%d:%d\t\tChannel_%d:%.2f v\n", adcChannel, data, adcChannel, temp);
        }
        printf("\nPress 'e' to close the program or 'enter' to rescan\n");
        scanf_s("%c", &exitChar);
    }
    /// Only De-initialize if your use the AC97 alone
    /// ret = Ac97DeInit;
    return TRUE;
}